open Parser

let rec parens()= (
  char '(' >>= fun _ ->
  parens() >>= fun _ ->
  char ')' >>= fun _ ->
  parens()
) <|> return()
let parens = parens()

let rec nesting() = (
  char '('  >>= fun _ ->
  nesting() >>= fun i ->
  char ')'  >>= fun _ ->
  nesting() >>= fun j ->
  return(max (i+1) j)
) <|> return 0
let nesting = nesting()

let word = many1 letter

let separator =
  many1(space <|> char ',') >>= fun _ ->
  return()

let sentence =
 sep_by1 word separator >>= fun ws ->
 oneof ".?!"            >>= fun _ ->
 return ws

let any_pair =
 any_char >>= fun c ->
 any_char >>= fun d ->
 return(c,d)

let braced_char = between (char '{') any_char (char '}')

let comma_chars = sep_by any_char (char ',')
